import FunctionLayer.Datahandler;
import FunctionLayer.PipelineJMWESingleton;
import FunctionLayer.StanfordParser.SentimentAnalyzerTest;
import edu.mit.jmwe.data.IMWE;
import edu.mit.jmwe.data.IToken;
import edu.stanford.nlp.ie.AbstractSequenceClassifier;
import edu.stanford.nlp.ie.crf.CRFClassifier;
import edu.stanford.nlp.ling.CoreAnnotations;
import edu.stanford.nlp.ling.CoreLabel;
import edu.stanford.nlp.ling.TaggedWord;
import edu.stanford.nlp.parser.lexparser.LexicalizedParser;
import edu.stanford.nlp.pipeline.Annotation;
import edu.stanford.nlp.pipeline.CoreDocument;
import edu.stanford.nlp.pipeline.StanfordCoreNLP;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;
import edu.stanford.nlp.trees.*;
import edu.stanford.nlp.util.CoreMap;
import org.ejml.simple.SimpleMatrix;
import org.junit.Assert;
import org.junit.Test;
import FunctionLayer.SimilarityMatrix;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.FileHandler;
import java.util.logging.Logger;
import java.util.logging.SimpleFormatter;

public class junit {

    private String taggerPath = "edu/stanford/nlp/models/pos-tagger/english-left3words-distsim.tagger";
    private MaxentTagger tagger = new MaxentTagger(taggerPath);
    private GrammaticalStructureFactory gsf = initiateGrammaticalStructureFactory();

    String nerModel = "edu/stanford/nlp/models/ner/english.all.3class.distsim.crf.ser.gz";
    AbstractSequenceClassifier<CoreLabel> classifier = CRFClassifier.
            getClassifierNoExceptions(nerModel);

    public GrammaticalStructureFactory initiateGrammaticalStructureFactory() {
        String lexParserEnglishPCFG = "edu/stanford/nlp/models/lexparser/englishPCFG.ser.gz";
        LexicalizedParser lp = LexicalizedParser.
                loadModel(lexParserEnglishPCFG, "-maxLength", "100");
        TreebankLanguagePack langpack = lp.getOp().langpack();
        return langpack.grammaticalStructureFactory();
    }

    public Double testCall(String sent1, String sent2, StanfordCoreNLP stanfordCoreNLP,
                           StanfordCoreNLP stanfordCoreNLPSentiment) {
        System.out.println("\n\n\n\nNEW ITERATION");
        System.out.println("sent1: " + sent1);
        System.out.println("sent2: " + sent2);
        ArrayList<String> concurrentRelations = new ArrayList<String>();
        Annotation jmweAnnotationF = PipelineJMWESingleton.INSTANCE.getJMWEAnnotation(sent1);
        Annotation jmweAnnotation = PipelineJMWESingleton.INSTANCE.getJMWEAnnotation(sent2);

        Integer tokenizeCountingF = null;
        List<List<TaggedWord>> taggedWordListF = null;
        List<List<TaggedWord>> taggedWordList1 = null;
        ArrayList<String> retrieveTGWListF = null;
        java.util.ArrayList<String> retrieveTGWList1 = null;
        List<CoreMap> sentencesF = null;
        List<CoreMap> sentence1 = null;
        List<CoreMap> sentencesSentimentF = null;
        List<CoreMap> sentenceSentiment1 = null;
        List<CoreMap> coreMaps1 = jmweAnnotationF.get(CoreAnnotations.SentencesAnnotation.class);
        ArrayList<Tree> treesF = null;
        ArrayList<Tree> trees1 = null;
        ArrayList<GrammaticalStructure> grammaticalStructuresF = null;
        ArrayList<GrammaticalStructure> grammaticalStructures1 = null;
        ArrayList<TypedDependency> typedDependenciesF = null;
        ArrayList<Integer> rnnCoreAnnotationsPredictedF = null;
        ArrayList<SimpleMatrix> simpleMatricesF = null;
        ArrayList<SimpleMatrix> simpleMatricesNodevectorsF = null;
        ArrayList<?> listF = null;
        Integer longestF = null;
        Integer sentimentLongestF = null;
        List<IMWE<IToken>> imwesF = null;
        Integer InflectedCounterNegativeF = null;
        Integer InflectedCounterPositiveF = null;
        ArrayList<String> tokenEntryF = null;
        Integer MarkedContinuousCounterF = null;
        Integer UnmarkedPatternCounterF = null;
        ArrayList<String> strTokensIpartFormF = null;
        ArrayList<String> tokenFormsF = null;
        ArrayList<String> strTokenEntryGetPOSF = null;
        ArrayList<Integer> intTokenEntyCountsF = null;
        ArrayList<String> ITokenTagsF = null;
        ArrayList<String> strTokenStemsF = null;
        Integer AnotatorcounterF = null;
        Integer TokensCounterF = null;
        ArrayList<String> entityTokenTagsF = null;
        ArrayList<String> nerEntitiesF = null;
        ArrayList<String> nerEntitiesTypeF = null;
        ArrayList<String> stopWordTokenF = null;
        ArrayList<String> stopWordLemmaF = null;
        Integer PairCounterF = null;

        java.util.ArrayList<TypedDependency> typedDependencies1 = null;
        ArrayList<Integer> rnnCoreAnnotationsPredicted1 = null;
        ArrayList<SimpleMatrix> simpleMatrices1 = null;
        ArrayList<SimpleMatrix> simpleMatricesNodevectors1 = null;
        List<?> list1 = null;
        Integer longest1 = null;
        Integer sentimentLongest1 = null;
        List<IMWE<IToken>> imwes1 = null;
        Integer InflectedCounterNegative1 = null;
        Integer InflectedCounterPositive1 = null;
        ArrayList<String> tokenEntry1 = null;
        Integer MarkedContinuousCounter1 = null;
        Integer UnmarkedPatternCounter1 = null;
        ArrayList<String> strTokensIpartForm1 = null;
        ArrayList<String> tokenForms1 = null;
        ArrayList<String> strTokenEntryGetPOS1 = null;
        ArrayList<Integer> intTokenEntyCounts1 = null;
        ArrayList<String> ITokenTags1 = null;
        ArrayList<String> strTokenStems1 = null;
        Integer Anotatorcounter1 = null;
        Integer TokensCounter1 = null;
        ArrayList<String> entityTokenTags1 = null;
        ArrayList<String> nerEntities1 = null;
        ArrayList<String> nerEntitiesType1 = null;
        ArrayList<String> stopWordToken1 = null;
        ArrayList<String> stopWordLemma1 = null;
        Integer PairCounter1 = null;
        List<CoreMap> coreMaps2 = jmweAnnotation.get(CoreAnnotations.SentencesAnnotation.class);
        Annotation strAnno = new Annotation(sent1);
        strAnno.compact();
        stanfordCoreNLP.annotate(strAnno);

        Annotation strAnnoSentiment = new Annotation(sent2);
        strAnnoSentiment.compact();
        stanfordCoreNLPSentiment.annotate(strAnnoSentiment);

        Annotation strAnno2 = new Annotation(sent2);
        strAnno2.compact();
        stanfordCoreNLP.annotate(strAnno2);

        Annotation strAnno22 = new Annotation(sent2);
        strAnno22.compact();
        stanfordCoreNLPSentiment.annotate(strAnno22);

        Annotation annotation = new Annotation(sent1);
        stanfordCoreNLP.annotate(annotation);
        CoreDocument coreDocument = new CoreDocument(annotation);

        annotation = new Annotation(sent2);
        stanfordCoreNLP.annotate(annotation);
        CoreDocument coreDocument1 = new CoreDocument(annotation);


        Integer tokenizeCounting = null;

        SentimentAnalyzerTest sentimentAnalyzerTest = new SentimentAnalyzerTest(sent1, sent2,
                new SimilarityMatrix(sent1, sent2), coreMaps1, coreMaps2, strAnno,
                strAnno2, strAnnoSentiment,
                strAnno22, coreDocument,
                coreDocument1,
                tagger, gsf, classifier, tokenizeCounting, tokenizeCountingF,
                taggedWordListF, taggedWordList1, retrieveTGWListF, retrieveTGWList1,
                sentencesF, sentence1, sentencesSentimentF, sentenceSentiment1, treesF, trees1,
                grammaticalStructuresF, grammaticalStructures1, typedDependenciesF,
                typedDependencies1, rnnCoreAnnotationsPredictedF, rnnCoreAnnotationsPredicted1,
                simpleMatricesF, simpleMatrices1, simpleMatricesNodevectorsF, simpleMatricesNodevectors1,
                listF, list1, longestF, longest1, sentimentLongestF, sentimentLongest1, imwesF,
                imwes1, InflectedCounterNegativeF, InflectedCounterNegative1, InflectedCounterPositiveF,
                InflectedCounterPositive1, tokenEntryF, tokenEntry1, MarkedContinuousCounterF,
                MarkedContinuousCounter1, UnmarkedPatternCounterF, UnmarkedPatternCounter1,
                strTokensIpartFormF, strTokensIpartForm1, tokenFormsF, tokenForms1,
                strTokenEntryGetPOSF, strTokenEntryGetPOS1, intTokenEntyCountsF,
                intTokenEntyCounts1, ITokenTagsF, ITokenTags1, strTokenStemsF, strTokenStems1,
                AnotatorcounterF, Anotatorcounter1, TokensCounterF, TokensCounter1,
                entityTokenTagsF, entityTokenTags1, nerEntitiesF, nerEntities1, nerEntitiesTypeF,
                nerEntitiesType1, stopWordTokenF, stopWordToken1, stopWordLemmaF, stopWordLemma1,
                PairCounterF, PairCounter1);
        Double score = sentimentAnalyzerTest.callSMX().getDistance();
        System.out.println("score: " + score + "\n");
        return score;
    }

    //@Test
    public void testScoring() {
        Datahandler datahandler = new Datahandler();
        PipelineJMWESingleton.getINSTANCE();
        StanfordCoreNLP stanfordCoreNLP = datahandler.pipeLineSetUp();
        StanfordCoreNLP stanfordCoreNLPSentiment = datahandler.shiftReduceParserInitiate();
        String sent1 = "I was thinking to small supplies to avoid waiting in the rain. This way, in case of trouble you go home and take in your supply instead of waiting 45 min";
        String sent2 = "*NêkØ* Kroaat_West bG <3";
        double PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 800.0);
        sent2 = "no thanks but i know some ladyboys here that would";
        sent1 = "u want head from me :wlenny:";
        double PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);

        Assert.assertTrue(PerformTestingFitting > 200.0);
        sent1 = "we need a trim for kroaat's teamwin";
        double PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        sent1 = "i am not a stalker";
        sent2 = "but we ban for bhop hack";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "hey stalker";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < PerformTestingFitting);
        sent1 = "what do you think of humanzz";
        sent2 = "did we actually go inside rocket -_-";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "crying for beeing tossed for fire";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        Assert.assertTrue(PerformTestingFitting > 3000);
        sent1 = "admin ! this map needs a Free Torchlight for all";
        sent2 = "( ? <:wlenny:514861023002624001>  ?? ? <:wlenny:514861023002624001> )   ( ? <:wlenny:514861023002624001>  ?? ? <:wlenny:514861023002624001> )   ( ? <:wlenny:514861023002624001>  ?? ? <:wlenny:514861023002624001> )   ( ? <:wlenny:514861023002624001>  ?? ?";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 100);
        sent1 = "i said that because i indeed have more knowledge about medicines than the average joe";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "Depends on the situation but i will mostly trust my doctor if he says this will help and i actually need it";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        sent1 = "tell me something";
        sent2 = "you learn fast yoshmi";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "when i see europeans dead i laugh";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        sent1 = "crobat im gonna nominate next event for you";
        sent2 = "why did we sploit . <:wlenny:514861023002624001>  <:wlenny:514861023002624001>  <:wlenny:514861023002624001>";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "lets go for mako";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        sent1 = "how are the calcluations going? any issue with the JMWE?";
        sent2 = "anyone know if upgrading damage increases the mines' damage also";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "i have to get back to work";
        PerformTestingFitting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFitting > PerformTestingFittingLess);
        sent1 = "sprichst du Deutsch?";
        sent2 = "like rpggift unknown !!! 130";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 500);
        sent1 = "do you like memes?";
        sent2 = "we need to adapt to the team we have";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 3400);
        sent2 = "i have to get back to work";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 4400);
        sent1 = "is that a cursed sentence?";
        sent2 = "just didnt want to have heal since i died";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2000);
        sent1 = "my name is ? ? ? ? G ? ? ? but this server doesn't read my special ? ? ? ? ? ? characters";
        sent2 = "dont say that sentence again";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 5000);
        sent2 = "please dont tell me your gonna repeat that";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2000);
        sent2 = "na it was a good try";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2000);
        sent2 = "NATSU DIES IN THE END";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2000);
        sent1 = "reeee";
        sent2 = "??( ? :wlenny~1:  ?? ? :wlenny~1: )?? ( ? :wlenny~1:  ?? ? :wlenny~1: )/ [ :wlenny~1:  ?~ :wlenny~1: :]   ? :wlenny~1: ??  ?? <";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "dw, my mom is a stupid cunt, she deserved it";
        sent2 = "(????????????-)---…..  JOINT :wlenny~1: !";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "are you a paste cut or a cut and paste?";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "Did you know that Denmark's short form (DK) is pronounced as \"decay\"? :thonk~1:";
        sent2 = "?( ? <:wlenny:514861023002624001>  ?? ? <:wlenny:514861023002624001> )??( ? <:wlenny:514861023002624001>  ?? ? <:wlenny:514861023002624001> )??( ? <:wlenny:514861023002624001>  ?? ?<:wlenny:514861023002624001>)??( ?<:wlenny:514861023002624001>?? ? <:w";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "are you a space cat or a cat in space? <:thonk:382012909942734858>";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "something else to tell me now";
        sent2 = "{fullred}(--)? ?(--? )?{mediumblue}?(--)? ?(--)?{magenta}?(--)?{indigo}?(--? )?";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "do you have repeating sentences";
        sent2 = "its pretty cheap with 10 ppl you pay about 60 euro for a week";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 5500);
        sent1 = "what is 60 euro a week";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "do you watch news and if yes which one";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTestingFittingLess = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTestingFittingLess < 2500);
        sent1 = "\"im gonna bad manner you";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "LOOK OUT BIG DOG";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "3 days = 30 cents";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = ":D we had a lot of fun for 2 rounds :D";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = ">FUCK I JUST PRESSED MY ZTELE BIND";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "400 solos on mako  <:wlenny:514861023002624001>";
        sent2 = "? ? ? ? ? ? ? ? A ? ?  ? V ? ? ? ? ? ? ? ? ?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "2 noobs 3 not bad";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "??????? NOW WE RIOT ???????";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "admin turn on bhop pleas";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "paranoid is never event";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "players keep diying LLLLOOOOLLL";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "PRESS THE FUCKING BUTTON IN THE ELEVATOR";
        sent2 = "{fullred}( ? <:wlenny:514861023002624001> ? ? {hotpink}? ? ?  ? ? ? ? ?  ? ? ?  ? ? ?  ? ? <:wlenny:514861023002624001> ?)";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "but instead of minecraft server i got css ze";
        sent2 = "Rocklee when did you come back from the isis khalifate <:wlenny:514861023002624001>";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 5500.0);
        sent1 = "First time there's that many CT at this point";
        sent2 = "Rocklee when did you come back from the isis khalifate <:wlenny:514861023002624001>";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "go to spec so changemap";
        sent2 = "Rocklee when did you come back from the isis khalifate <:wlenny:514861023002624001>";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "What's for lunch?";
        sent2 = "what does bm stand for";
        double PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "2 eggs and 1 cup";
        double PerformTesting2 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < PerformTesting2);
        sent1 = "do you watch any series or animes or cartoons";
        sent2 = "you guys voted for this";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 5500);
        sent1 = "do you know pyrono";
        sent2 = "i have to get accustomed to it";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 2000);
        sent1 = "Is William a good admin?";
        sent2 = "but this is helms deep";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        sent2 = "keep an eye on them";
        PerformTesting2 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting2 > PerformTesting1);
        sent1 = "scuffed jenz";
        sent2 = "I HAVE WATCHED ONLY ONE CARTOON AND IT'S POKEMON";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 2500);
        sent1 = "So what?";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 5500);
        sent1 = "Who is the enemy?";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 2500);
        sent1 = "Sounds bad, doesn't work";
        sent2 = "that hold is identical to the other room";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 2500);
        sent1 = "oh wait, because I don't have any";
        sent2 = "would be cool if VIPs would nominate other than paranoid. All the maps in the vote all the time suck so people just vote for an";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 4500);
        sent1 = "{navy}?  :wlenny~1:   ??  {violet}? :wlenny~1:  ? :wlenny~1:   ? :wlenny~1:   ??  ? :wlenny~1:  ? :wlenny~1:    ? :wlenny~1:   ??";
        sent2 = "will you still be online tommorow?";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 4500);
        sent1 = "stop being such a kid and act more polite towards people ";
        sent2 = "i played nemesis on paradise a few days ago and it worked fine";
        PerformTesting1 = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting1 < 6500);
        sent1 = "Enfin. Map noob";
        sent2 = "dagger dagger";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "u have to hit the middle one with ur nade";
        sent2 = "your not going to mcdonalds, you have had your chance with the cheeseburger";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 1400.0);
        sent1 = "How is everyone doing";
        sent2 = "wieso ist dein Bein am Arsch. Eigdl hängt das runter";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent2 = "meshlem how does it feel to be russian";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 700.0);

        //new pairs
        sent1 = "they dont buy kefvlar";
        sent2 = "you have a database available again";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "because of lag?";
        sent2 = "french tourit";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent2 = "Even when I'm working";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 3500.0);
        sent1 = "or need another restart";
        sent2 = "Even when I'm working";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 600.0);
        sent2 = "french tourit";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "wow that clock works/";
        sent2 = "didnt the bot like mako? what happened to that?";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "haHAA stop that cringe chat haHAA";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "like 1s down now i guess i will die";
        sent2 = "monkaGIGA";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "what do you want";
        sent2 = "admun extend";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting > 100.0);
        sent1 = "You are a one large bug";
        sent2 = "omg you are right";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting > 5900.0);
        sent1 = "I'm not a mapper, wtf";
        sent2 = "this map was made by wtf";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting > 1400.0);
        sent1 = "do you have plants thonk";
        sent2 = "banana trees are plants";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting > 1400.0);
        sent2 = "fucking alcolo";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 600.0);
        sent2 = "qual arma e 382012909942734858";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < -400.0);
        sent2 = "wlenny on gamebanana";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 2500.0);
        sent1 = "And how was it? :wlenny~1:";
        sent2 = "at lvl 1 avad is 140 cd";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < 400.0);
        sent1 = "wtf? :monkaS~2:";
        sent2 = "think thats it kangaroo next";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < -400.0);
        sent1 = "yurope";
        sent2 = "?? ??????? ??? ??";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < -2400.0);
        sent1 = "fuck";
        PerformTesting = testCall(sent1, sent2, stanfordCoreNLP, stanfordCoreNLPSentiment);
        Assert.assertTrue(PerformTesting < -2400.0);
    }
}

